@echo off
 @ REM ######################################
 @ REM # Variable to ignore <CR> in DOS
 @ REM # line endings
 @ set SHELLOPTS=igncr

@ REM ######################################
 @ REM # Variable to ignore mixed paths
 @ REM # i.e. G:/$SOPC_KIT_NIOS2/bin
 @ set CYGWIN=nodosfilewarning


@set QUARTUS_BIN=%QUARTUS_ROOTDIR%\\bin
 @if exist %QUARTUS_BIN%\\quartus_pgm.exe (goto DownLoad)

@set QUARTUS_BIN=%QUARTUS_ROOTDIR%\\bin64
 @if exist %QUARTUS_BIN%\\quartus_pgm.exe (goto DownLoad)

:: Prepare for future use (if exes are in bin32)
 @set QUARTUS_BIN=%QUARTUS_ROOTDIR%\\bin32

:DownLoad

%QUARTUS_ROOTDIR%\bin64\jtagconfig.exe --setparam 1 JtagClock 16M
%QUARTUS_ROOTDIR%\bin64\jtagconfig.exe --getparam 1 JtagClock

 set project.sof=default_code.sof
 set project.jic=default_code.jic
 set device_sfl.sof=flik_sfl.sof
 goto main

:main
 echo **********************************
 echo Makesure MSEL[2:0] is set to "010"
echo Plesase choose your operation
 echo "1" for programming .sof to FPGA.
 echo "2" for converting .sof to .jic
echo "3" for programming .jic to MT25QU01G.
 echo "4" for erasing .jic from MT25QU01G.
 echo **********************************
 choice /C 1234 /M "Please enter your choise:"
if errorlevel 4 goto d
if errorlevel 3 goto c
 if errorlevel 2 goto b
 if errorlevel 1 goto a


:a
 echo ===========================================================
 echo "Progrming .sof to FPGA"
 echo ===========================================================
 %QUARTUS_BIN%\\quartus_pgm.exe -m jtag -c 1 -o "p;%project.sof%"
 @ set SOPC_BUILDER_PATH=%SOPC_KIT_NIOS2%+%SOPC_BUILDER_PATH%
 goto end


:b
echo ===========================================================
 echo "Convert .sof to .jic"
 echo ===========================================================
 %QUARTUS_BIN%\\quartus_cpf -c -d MT25QU01G -s 10AX115N3F40E2SG -m ASx4 %project.sof% %project.jic%
 goto end

:c
 echo ===========================================================
 echo "Programming MT25QU01G with .jic"
 echo ===========================================================
 %QUARTUS_BIN%\\quartus_pgm.exe -m jtag -c 1 -o "p;%device_sfl.sof%"
 %QUARTUS_BIN%\\quartus_pgm.exe -m jtag -c 1 -o "p;%project.jic%"
 goto end

:d
 echo ===========================================================
 echo "Erasing MT25QU01G with .jic"
 echo ===========================================================
 %QUARTUS_BIN%\\quartus_pgm.exe -m jtag -c 1 -o "p;%device_sfl.sof%"
 %QUARTUS_BIN%\\quartus_pgm.exe -m jtag -c 1 -o "r;%project.jic%"
 goto end

:end
 echo Job Done!!
 goto main
